#!/usr/bin/env node
const { program } = require('commander');
const chalk = require('chalk'); // 控制台输出文字的颜色

program
  .command('start')
  .description('start run project')
  .action(async (name, ver, desc) => {
    require('../config/webpack.project.start.js');
  });

program
  .command('build')
  .description('build project')
  .action(async (name, ver, desc) => {
    require('../config/webpack.project.build.js');
  });

program
  .command('pack [config=icode.config.js]')
  .description('pack components')
  .action(async (name, ver, desc) => {
    require('../config/webpack.pack.js');
  });

// program
//   .command('getSize')
//   .description('pack components')
//   .action(async (name, ver, desc) => {
//     require('../config/size.js');
//   });

program.on('option:verbose', function() {
  process.env.VERBOSE = this.verbose;
});

// 未知命令会报错
program.on('command:*', function(operands) {
  console.log(chalk.red(`error: unknown command '${operands[0]}'.`));
  console.log(chalk.red('See --help for a list of available commands.'));
  process.exit(1);
});

program.parse(process.argv);
