import request from '@/utils/request';

const getPageStatus = async(dispatch, history, count, preStatus) => {
  const isBuilding = await dispatch({
    type: 'getPageStatus',
    payload: {
      path: history.location.pathname,
    },
  });
  if(isBuilding && count < 50) {
    setTimeout(() => {
      return getPageStatus(dispatch, history, (count || 0) + 1, isBuilding);
    }, 1000)
  }
  else {
    dispatch({
      type: 'setState',
      payload: {
        isBuilding: false,
      },
    });
    if(parseInt(preStatus, 10)) {
      window.location.reload();
    }
  }
}

export default {
  namespace: 'authModel',

  state: {
    isBuilding: true
  },

  effects: {
    *getPageStatus({ payload }, { put }) {
      const res = yield request({
        url: '/lowcodeApi/getPreviewBuildStatus',
        method: 'POST',
        body: payload
      });
      const isBuilding = res && res.data && res.data.isBuilding;
      return isBuilding;
    },
  },

  reducers: {
    setState(state, { payload }) {
      return {
        ...state,
        ...payload,
      };
    },
  },

  subscriptions: {
    setup({ history, dispatch }) {
      getPageStatus(dispatch, history, 0)
    },
  },
};
